import chalk from 'chalk-template';
import { Effect, pipe } from 'effect';
import { ICON } from '../constants.js';
import { toJson } from './to-json.js';
import { writeFileSync } from './write-file-sync.js';
export function writeIfChanged(ctx) {
    return pipe(Effect.all(ctx.packageJsonFiles.map((file) => pipe(Effect.Do, Effect.bind('nextJson', () => Effect.succeed(toJson(ctx, file))), Effect.bind('hasChanged', ({ nextJson }) => Effect.succeed(file.jsonFile.json !== nextJson)), Effect.flatMap(({ hasChanged, nextJson }) => hasChanged
        ? pipe(writeFileSync(file.jsonFile.filePath, nextJson), Effect.flatMap(() => Effect.logInfo(chalk `{green ${ICON.tick}} ${file.jsonFile.shortPath}`)))
        : Effect.logInfo(chalk `{dim ${ICON.skip} ${file.jsonFile.shortPath}}`))))), Effect.map(() => ctx));
}
